config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  devise_for :users

  resources :quizzes, except: :show do
    resources :quiz_answers, only: %i[new create]
  end
  resources :questions, only: %i[index new create destroy]

  root 'quizzes#index'
end

app/models/question.rb
# frozen_string_literal: true

class Question < ApplicationRecord
  has_many :quiz_questions, dependent: :restrict_with_error
  has_many :quizzes, through: :quiz_questions
  has_many :alternatives, dependent: :destroy

  accepts_nested_attributes_for :alternatives

  validates :statement, presence: true
  validate :must_have_alternatives

  def multiple?
    alternatives.select(&:correct?).count > 1
  end

  private

  def must_have_alternatives
    return if alternatives.any?(&:correct?)

    errors.add(:base, :must_have_alternatives)
  end
end

app/controllers/questions_controller.rb
# frozen_string_literal: true

class QuestionsController < ApplicationController
  def index
    @questions = Question.all
  end

  def new
    @question = Question.new
  end

  def create
    @question = Question.new(question_params)

    respond_to do |format|
      if @question.save
        format.html { redirect_to questions_url, notice: 'Question was successfully created.' }
        format.json { head :created }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @question.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @question = Question.find(params[:id])

    respond_to do |format|
      if @question.destroy
        format.html { redirect_to questions_url, notice: 'Question was successfully destroyed.' }
        format.json { head :no_content }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @question.errors, status: :unprocessable_entity }
      end
    end
  end

  private

  def question_params
    params.require(:question).permit(
      :statement, :description, alternatives_attributes: %i[id statement description correct]
    )
  end
end

app/views/questions/_alternative_fields.html.erb
<div class="nested-fields">
  <div>
    <%= f.label :statement, style: "display: block" %>
    <%= f.text_field :statement %>
  </div>

  <div>
    <%= f.label :description, style: "display: block" %>
    <%= f.text_field :description %>
  </div>

  <div>
    <%= f.label :correct, style: "display: block" %>
    <%= f.check_box :correct %>
  </div>

  <%= link_to_remove_association "Delete", f %>
</div>

app/views/questions/_form.html.erb
<%= form_for @question do |form| %>
  <% if @question.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(@question.errors.count, "error") %> prohibited this question from being saved:</h2>

      <ul>
        <% @question.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :statement, style: "display: block" %>
    <%= form.text_field :statement %>
  </div>

  <div>
    <%= form.label :description, style: "display: block" %>
    <%= form.text_field :description %>
  </div>

  <h3>Alternatives</h3>

  <div id="alternatives">
    <%= form.fields_for :alternatives do |alternative| %>    
      <%= render 'alternative_fields', f: alternative %>
    <% end %>
    <%= link_to_add_association "Add alternative", form, :alternatives %>
  </div>  

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/questions/_question.html.erb
<div>
  <p>
    <strong>Statement:</strong>
    <%= question.statement %>
  </p>

  <p>
    <strong>Description:</strong>
    <%= question.description %>
  </p>
</div>

app/views/questions/edit.html.erb
<h1>Editing question</h1>

<%= render "form", question: @question %>

<br>

<div>  
  <%= link_to "Back", questions_path %>
</div>

app/views/questions/index.html.erb
<h1>Questions</h1>

<div id="questions">
  <% @questions.each do |question| %>
    <%= render question %>
    <p>
      <%= link_to "Delete", question_path(question.id), data: { turbo_method: :delete } %>
    </p>
  <% end %>
</div>

<%= link_to "New question", new_question_path %>

app/views/questions/new.html.erb
<h1>New question</h1>

<%= render "form", question: @question %>

<br>

<div>
  <%= link_to "Back", questions_path %>
</div>